diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-mgt-header.h ns-3.45/src/wifi/model/wifi-mgt-header.h
--- ns-3.44/src/wifi/model/wifi-mgt-header.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-mgt-header.h	2025-06-01 20:34:45.628702200 -0700
@@ -13,8 +13,10 @@
 #include "supported-rates.h"
 
 #include "ns3/eht-capabilities.h"
+#include "ns3/he-6ghz-band-capabilities.h"
 #include "ns3/header.h"
 #include "ns3/multi-link-element.h"
+#include "ns3/vht-capabilities.h"
 
 #include <algorithm>
 #include <iterator>
@@ -363,11 +365,9 @@
 WifiMgtHeader<Derived, std::tuple<Elems...>>::InitForDeserialization(
     std::optional<EhtCapabilities>& optElem)
 {
-    NS_ASSERT(Get<SupportedRates>());
-    auto rates = AllSupportedRates{*Get<SupportedRates>(), std::nullopt};
-    const bool is2_4Ghz = rates.IsSupportedRate(
-        1000000 /* 1 Mbit/s */); // TODO: use presence of VHT capabilities IE and HE 6 GHz Band
-                                 // Capabilities IE once the later is implemented
+    auto& vhtCapabilities = Get<VhtCapabilities>();
+    auto& he6GhzBandCapabilities = Get<He6GhzBandCapabilities>();
+    const auto is2_4Ghz = !vhtCapabilities && !he6GhzBandCapabilities;
     auto& heCapabilities = Get<HeCapabilities>();
     if (heCapabilities)
     {
@@ -572,7 +572,7 @@
 {
     if (elem.has_value())
     {
-        os << *elem << " , ";
+        os << *elem << ", ";
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-mode.cc ns-3.45/src/wifi/model/wifi-mode.cc
--- ns-3.44/src/wifi/model/wifi-mode.cc	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-mode.cc	2025-06-01 20:34:45.628702200 -0700
@@ -11,7 +11,6 @@
 
 #include "wifi-tx-vector.h"
 
-#include "ns3/he-ru.h"
 #include "ns3/log.h"
 
 #include <cmath>
@@ -158,8 +157,7 @@
     }
     else
     {
-        // We should not go here!
-        NS_ASSERT(false);
+        NS_ASSERT_MSG(false, "GetMcsValue() cannot be called for non-HT modulations");
         return 0;
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-mode.h ns-3.45/src/wifi/model/wifi-mode.h
--- ns-3.44/src/wifi/model/wifi-mode.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-mode.h	2025-06-01 20:34:45.628702200 -0700
@@ -10,6 +10,7 @@
 #ifndef WIFI_MODE_H
 #define WIFI_MODE_H
 
+#include "wifi-constants.h"
 #include "wifi-phy-common.h"
 
 #include "ns3/attribute-helper.h"
@@ -20,9 +21,6 @@
 namespace ns3
 {
 
-/// STA_ID to identify a single user (SU)
-static constexpr uint16_t SU_STA_ID = 65535;
-
 class WifiTxVector;
 
 /**
@@ -113,6 +111,9 @@
     uint16_t GetConstellationSize() const;
     /**
      * @returns the MCS value.
+     *
+     * This method cannot be called for non-HT modulations, because Modulation and Coding Scheme
+     * (MCS) is a concept introduced by the 802.11n amendment.
      */
     uint8_t GetMcsValue() const;
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-net-device.cc ns-3.45/src/wifi/model/wifi-net-device.cc
--- ns-3.44/src/wifi/model/wifi-net-device.cc	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-net-device.cc	2025-06-01 20:34:45.629702300 -0700
@@ -44,19 +44,11 @@
                           UintegerValue(MAX_MSDU_SIZE - LLC_SNAP_HEADER_LENGTH),
                           MakeUintegerAccessor(&WifiNetDevice::SetMtu, &WifiNetDevice::GetMtu),
                           MakeUintegerChecker<uint16_t>(1, MAX_MSDU_SIZE - LLC_SNAP_HEADER_LENGTH))
-            .AddAttribute("Channel",
-                          "The channel attached to this device",
-                          PointerValue(),
-                          MakePointerAccessor(&WifiNetDevice::GetChannel),
-                          MakePointerChecker<Channel>(),
-                          TypeId::SupportLevel::DEPRECATED,
-                          "class WifiNetDevice; use the Channel "
-                          "attribute of WifiPhy")
             .AddAttribute("Phy",
                           "The PHY layer attached to this device.",
                           PointerValue(),
-                          MakePointerAccessor((Ptr<WifiPhy>(WifiNetDevice::*)() const) &
-                                                  WifiNetDevice::GetPhy,
+                          MakePointerAccessor(static_cast<Ptr<WifiPhy> (WifiNetDevice::*)() const>(
+                                                  &WifiNetDevice::GetPhy),
                                               &WifiNetDevice::SetPhy),
                           MakePointerChecker<WifiPhy>())
             .AddAttribute(
@@ -70,14 +62,14 @@
                           PointerValue(),
                           MakePointerAccessor(&WifiNetDevice::GetMac, &WifiNetDevice::SetMac),
                           MakePointerChecker<WifiMac>())
-            .AddAttribute(
-                "RemoteStationManager",
-                "The station manager attached to this device.",
-                PointerValue(),
-                MakePointerAccessor(&WifiNetDevice::SetRemoteStationManager,
-                                    (Ptr<WifiRemoteStationManager>(WifiNetDevice::*)() const) &
-                                        WifiNetDevice::GetRemoteStationManager),
-                MakePointerChecker<WifiRemoteStationManager>())
+            .AddAttribute("RemoteStationManager",
+                          "The station manager attached to this device.",
+                          PointerValue(),
+                          MakePointerAccessor(
+                              &WifiNetDevice::SetRemoteStationManager,
+                              static_cast<Ptr<WifiRemoteStationManager> (WifiNetDevice::*)() const>(
+                                  &WifiNetDevice::GetRemoteStationManager)),
+                          MakePointerChecker<WifiRemoteStationManager>())
             .AddAttribute("RemoteStationManagers",
                           "The remote station managers attached to this device (11be multi-link "
                           "devices only).",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-net-device.h ns-3.45/src/wifi/model/wifi-net-device.h
--- ns-3.44/src/wifi/model/wifi-net-device.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-net-device.h	2025-06-01 20:34:45.629702300 -0700
@@ -28,9 +28,6 @@
 class HeConfiguration;
 class EhtConfiguration;
 
-/// This value conforms to the 802.11 specification
-static const uint16_t MAX_MSDU_SIZE = 2304;
-
 /**
  * @defgroup wifi Wifi Models
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-phy.cc ns-3.45/src/wifi/model/wifi-phy.cc
--- ns-3.44/src/wifi/model/wifi-phy.cc	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-phy.cc	2025-06-01 20:34:45.630702300 -0700
@@ -90,7 +90,8 @@
                 StringValue("{0, 0, BAND_UNSPECIFIED, 0}"),
                 MakeAttributeContainerAccessor<
                     TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue>,
-                    ';'>((void(WifiPhy::*)(const ChannelSegments&)) & WifiPhy::SetOperatingChannel),
+                    ';'>(static_cast<void (WifiPhy::*)(const ChannelSegments&)>(
+                    &WifiPhy::SetOperatingChannel)),
                 MakeAttributeContainerChecker<
                     TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue>,
                     ';'>(MakeTupleChecker<UintegerValue,
@@ -98,7 +99,7 @@
                                           EnumValue<WifiPhyBand>,
                                           UintegerValue>(
                     MakeUintegerChecker<uint8_t>(0, 233),
-                    MakeUintegerChecker<MHz_u>(0, 160),
+                    MakeUintegerChecker<MHz_u>(0, 320),
                     MakeEnumChecker(WifiPhyBand::WIFI_PHY_BAND_2_4GHZ,
                                     "BAND_2_4GHZ",
                                     WifiPhyBand::WIFI_PHY_BAND_5GHZ,
@@ -107,7 +108,7 @@
                                     "BAND_6GHZ",
                                     WifiPhyBand::WIFI_PHY_BAND_UNSPECIFIED,
                                     "BAND_UNSPECIFIED"),
-                    MakeUintegerChecker<uint8_t>(0, 7))))
+                    MakeUintegerChecker<uint8_t>(0, 15))))
             .AddAttribute("Frequency",
                           "The center frequency (MHz) of the current operating channel.",
                           TypeId::ATTR_GET,
@@ -122,12 +123,13 @@
                           MakeUintegerChecker<uint8_t>(0, 233))
             .AddAttribute(
                 "ChannelWidth",
-                "The width in MHz of the current operating channel (5, 10, 20, 22, 40, 80 or 160). "
-                "If 80+80MHz is used, this corresponds to the total channel width, hence 160 MHz.",
+                "The width in MHz of the current operating channel (5, 10, 20, 22, 40, 80, 160 or "
+                "320). If 80+80MHz is used, this corresponds to the total channel width, hence 160 "
+                "MHz.",
                 TypeId::ATTR_GET,
                 UintegerValue(0),
                 MakeUintegerAccessor(&WifiPhy::GetChannelWidth),
-                MakeUintegerChecker<MHz_u>(5, 160))
+                MakeUintegerChecker<MHz_u>(5, 320))
             .AddAttribute(
                 "Primary20MHzIndex",
                 "The index of the primary 20 MHz channel within the current operating channel "
@@ -141,6 +143,15 @@
                           MakeBooleanAccessor(&WifiPhy::SetFixedPhyBand, &WifiPhy::HasFixedPhyBand),
                           MakeBooleanChecker())
             .AddAttribute(
+                "MaxRadioBw",
+                "The maximum width supported by the radio. It is not possible to configure an "
+                "operating channel with a total width larger than this value. A value of 0 means "
+                "no restriction.",
+                TypeId::ATTR_GET | TypeId::ATTR_CONSTRUCT, // prevent setting after construction
+                DoubleValue(MHz_u{0}),
+                MakeDoubleAccessor(&WifiPhy::m_maxRadioBw),
+                MakeDoubleChecker<MHz_u>())
+            .AddAttribute(
                 "RxSensitivity",
                 "The energy of a received signal should be higher than "
                 "this threshold (dBm) for the PHY to detect the signal. "
@@ -388,8 +399,6 @@
       m_sifs(),
       m_slot(),
       m_pifs(),
-      m_ackTxTime(),
-      m_blockAckTxTime(),
       m_powerRestricted(false),
       m_channelAccessRequested(false),
       m_txSpatialStreams(1),
@@ -855,18 +864,6 @@
     return m_pifs;
 }
 
-Time
-WifiPhy::GetAckTxTime() const
-{
-    return m_ackTxTime;
-}
-
-Time
-WifiPhy::GetBlockAckTxTime() const
-{
-    return m_blockAckTxTime;
-}
-
 void
 WifiPhy::Configure80211a()
 {
@@ -874,12 +871,11 @@
     AddPhyEntity(WIFI_MOD_CLASS_OFDM, Create<OfdmPhy>());
 
     // See Table 17-21 "OFDM PHY characteristics" of 802.11-2016
-    SetSifs(MicroSeconds(16));
-    SetSlot(MicroSeconds(9));
+    SetSifs(OFDM_SIFS_TIME_20MHZ);
+    SetSlot(OFDM_SLOT_TIME_20MHZ);
     SetPifs(GetSifs() + GetSlot());
     // See Table 10-5 "Determination of the EstimatedAckTxTime based on properties
     // of the PPDU causing the EIFS" of 802.11-2016
-    m_ackTxTime = MicroSeconds(44);
 }
 
 void
@@ -890,13 +886,11 @@
     AddPhyEntity(WIFI_MOD_CLASS_HR_DSSS, phyEntity);
     AddPhyEntity(WIFI_MOD_CLASS_DSSS, phyEntity); // when plain DSSS modes are used
 
-    // See Table 16-4 "HR/DSSS PHY characteristics" of 802.11-2016
-    SetSifs(MicroSeconds(10));
-    SetSlot(MicroSeconds(20));
+    SetSifs(DSSS_SIFS_TIME);
+    SetSlot(DSSS_SLOT_TIME);
     SetPifs(GetSifs() + GetSlot());
     // See Table 10-5 "Determination of the EstimatedAckTxTime based on properties
     // of the PPDU causing the EIFS" of 802.11-2016
-    m_ackTxTime = MicroSeconds(304);
 }
 
 void
@@ -921,20 +915,18 @@
         AddPhyEntity(WIFI_MOD_CLASS_OFDM, Create<OfdmPhy>(OFDM_PHY_10_MHZ));
 
         // See Table 17-21 "OFDM PHY characteristics" of 802.11-2016
-        SetSifs(MicroSeconds(32));
-        SetSlot(MicroSeconds(13));
+        SetSifs(OFDM_SIFS_TIME_10MHZ);
+        SetSlot(OFDM_SLOT_TIME_10MHZ);
         SetPifs(GetSifs() + GetSlot());
-        m_ackTxTime = MicroSeconds(88);
     }
     else if (GetChannelWidth() == MHz_u{5})
     {
         AddPhyEntity(WIFI_MOD_CLASS_OFDM, Create<OfdmPhy>(OFDM_PHY_5_MHZ));
 
         // See Table 17-21 "OFDM PHY characteristics" of 802.11-2016
-        SetSifs(MicroSeconds(64));
-        SetSlot(MicroSeconds(21));
+        SetSifs(OFDM_SIFS_TIME_5MHZ);
+        SetSlot(OFDM_SLOT_TIME_5MHZ);
         SetPifs(GetSifs() + GetSlot());
-        m_ackTxTime = MicroSeconds(176);
     }
     else
     {
@@ -955,10 +947,6 @@
         Configure80211a();
     }
     AddPhyEntity(WIFI_MOD_CLASS_HT, Create<HtPhy>(m_txSpatialStreams));
-
-    // See Table 10-5 "Determination of the EstimatedAckTxTime based on properties
-    // of the PPDU causing the EIFS" of 802.11-2016
-    m_blockAckTxTime = MicroSeconds(68);
 }
 
 void
@@ -1287,25 +1275,13 @@
     m_operatingChannel.SetPrimary20Index(std::get<3>(m_channelSettings.front()));
 
     // check that the channel width is supported
-    const auto chWidth = GetChannelWidth();
-
-    if (m_device)
+    if (const auto chWidth = GetChannelWidth();
+        (m_maxRadioBw != MHz_u{0}) && (chWidth > m_maxRadioBw))
     {
-        if (auto htConfig = m_device->GetHtConfiguration();
-            htConfig && !htConfig->m_40MHzSupported && chWidth > MHz_u{20})
-        {
-            NS_ABORT_MSG("Attempting to set a " << chWidth
-                                                << " MHz channel on"
-                                                   "a station only supporting 20 MHz operation");
-        }
-
-        if (auto vhtConfig = m_device->GetVhtConfiguration();
-            vhtConfig && !vhtConfig->m_160MHzSupported && chWidth > MHz_u{80})
-        {
-            NS_ABORT_MSG("Attempting to set a " << chWidth
-                                                << " MHz channel on"
-                                                   "a station supporting up to 80 MHz operation");
-        }
+        // throw an exception instead of using NS_ABORT_MSG for unit testing this code
+        throw std::runtime_error("Attempting to set a " + std::to_string(chWidth) +
+                                 " MHz channel on a station only supporting " +
+                                 std::to_string(m_maxRadioBw) + " MHz operation");
     }
 
     if (changingPhyBand)
@@ -1589,6 +1565,7 @@
                              WifiPhyBand band,
                              uint16_t staId)
 {
+    NS_ASSERT(txVector.IsValid(band));
     Time duration = CalculatePhyPreambleAndHeaderDuration(txVector) +
                     GetPayloadDuration(size, txVector, band, NORMAL_MPDU, staId);
     NS_ASSERT(duration.IsStrictlyPositive());
@@ -1608,6 +1585,7 @@
                              const WifiTxVector& txVector,
                              WifiPhyBand band)
 {
+    NS_ASSERT(txVector.IsValid(band));
     return GetStaticPhyEntity(txVector.GetModulationClass())
         ->CalculateTxDuration(psduMap, txVector, band);
 }
@@ -1798,6 +1776,19 @@
 }
 
 std::optional<Time>
+WifiPhy::GetTimeToPreambleDetectionEnd() const
+{
+    for (const auto& [modClass, phyEntity] : m_phyEntities)
+    {
+        if (auto remTime = phyEntity->GetTimeToPreambleDetectionEnd())
+        {
+            return remTime;
+        }
+    }
+    return std::nullopt;
+}
+
+std::optional<Time>
 WifiPhy::GetTimeToMacHdrEnd(uint16_t staId) const
 {
     for (auto& [modClass, phyEntity] : m_phyEntities)
@@ -1876,20 +1867,15 @@
 
     const auto txDuration = CalculateTxDuration(psdus, txVector, GetPhyBand());
 
-    auto noEndPreambleDetectionEvent = true;
-    for (const auto& [mc, entity] : m_phyEntities)
-    {
-        noEndPreambleDetectionEvent =
-            noEndPreambleDetectionEvent && entity->NoEndPreambleDetectionEvents();
-    }
-    if (!noEndPreambleDetectionEvent && !m_currentEvent)
+    if (const auto timeToPreambleDetectionEnd = GetTimeToPreambleDetectionEnd();
+        timeToPreambleDetectionEnd && !m_currentEvent)
     {
         // PHY is in the initial few microseconds during which the
         // start of RX has occurred but the preamble detection period
         // has not elapsed
         AbortCurrentReception(SIGNAL_DETECTION_ABORTED_BY_TX);
     }
-    else if (!noEndPreambleDetectionEvent || m_currentEvent)
+    else if (timeToPreambleDetectionEnd || m_currentEvent)
     {
         AbortCurrentReception(RECEPTION_ABORTED_BY_TX);
     }
@@ -1968,13 +1954,7 @@
 {
     NS_LOG_FUNCTION(this);
     m_currentPreambleEvents.clear();
-    bool noEndPreambleDetectionEvent = true;
-    for (const auto& [mc, entity] : m_phyEntities)
-    {
-        noEndPreambleDetectionEvent =
-            noEndPreambleDetectionEvent && entity->NoEndPreambleDetectionEvents();
-    }
-    if (m_interference && (m_currentEvent || !noEndPreambleDetectionEvent))
+    if (m_interference && (m_currentEvent || GetTimeToPreambleDetectionEnd()))
     {
         m_interference->NotifyRxEnd(Simulator::Now(), GetCurrentFrequencyRange());
     }
@@ -2394,21 +2374,21 @@
     case WIFI_STANDARD_80211b:
     case WIFI_STANDARD_80211n:
     case WIFI_STANDARD_80211ac:
-        subcarrierSpacing = Hz_u{312500};
+        subcarrierSpacing = SUBCARRIER_FREQUENCY_SPACING;
         break;
     case WIFI_STANDARD_80211p:
         if (GetChannelWidth() == MHz_u{5})
         {
-            subcarrierSpacing = Hz_u{78125};
+            subcarrierSpacing = SUBCARRIER_FREQUENCY_SPACING / 4;
         }
         else
         {
-            subcarrierSpacing = Hz_u{156250};
+            subcarrierSpacing = SUBCARRIER_FREQUENCY_SPACING / 2;
         }
         break;
     case WIFI_STANDARD_80211ax:
     case WIFI_STANDARD_80211be:
-        subcarrierSpacing = Hz_u{78125};
+        subcarrierSpacing = SUBCARRIER_FREQUENCY_SPACING_HE;
         break;
     default:
         NS_FATAL_ERROR("Standard unknown: " << GetStandard());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-phy-common.cc ns-3.45/src/wifi/model/wifi-phy-common.cc
--- ns-3.44/src/wifi/model/wifi-phy-common.cc	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-phy-common.cc	2025-06-01 20:34:45.629702300 -0700
@@ -232,6 +232,45 @@
     return modulationClass;
 }
 
+std::set<MHz_u>
+GetSupportedChannelWidthSet(WifiStandard standard, WifiPhyBand band)
+{
+    switch (standard)
+    {
+    case WIFI_STANDARD_80211p:
+        return {MHz_u{5}};
+    case WIFI_STANDARD_80211a:
+    case WIFI_STANDARD_80211g:
+        return {MHz_u{20}};
+    case WIFI_STANDARD_80211b:
+        return {MHz_u{22}};
+    case WIFI_STANDARD_80211n:
+        return {MHz_u{20}, MHz_u{40}};
+    case WIFI_STANDARD_80211ac:
+        return {MHz_u{80}, MHz_u{160}};
+    case WIFI_STANDARD_80211ax:
+        return (band == WifiPhyBand::WIFI_PHY_BAND_2_4GHZ)
+                   ? std::set<MHz_u>{MHz_u{20}, MHz_u{40}}
+                   : std::set<MHz_u>{MHz_u{20}, MHz_u{80}, MHz_u{160}};
+    case WIFI_STANDARD_80211be:
+        switch (band)
+        {
+        case WifiPhyBand::WIFI_PHY_BAND_2_4GHZ:
+            return {MHz_u{20}, MHz_u{40}};
+        case WifiPhyBand::WIFI_PHY_BAND_5GHZ:
+            return {MHz_u{20}, MHz_u{80}, MHz_u{160}};
+        case WifiPhyBand::WIFI_PHY_BAND_6GHZ:
+            return {MHz_u{20}, MHz_u{80}, MHz_u{160}, MHz_u{320}};
+        default:
+            NS_ABORT_MSG("Unknown band: " << band);
+            return {};
+        }
+    default:
+        NS_ABORT_MSG("Unknown standard: " << standard);
+        return {};
+    }
+}
+
 MHz_u
 GetMaximumChannelWidth(WifiModulationClass modulation)
 {
@@ -245,14 +284,11 @@
         return MHz_u{20};
     case WIFI_MOD_CLASS_HT:
         return MHz_u{40};
-    // NOLINTBEGIN(bugprone-branch-clone)
     case WIFI_MOD_CLASS_VHT:
     case WIFI_MOD_CLASS_HE:
         return MHz_u{160};
     case WIFI_MOD_CLASS_EHT:
-        return MHz_u{
-            160}; // TODO update when 320 MHz channels are supported and remove clang-tidy guards
-    // NOLINTEND(bugprone-branch-clone)
+        return MHz_u{320};
     default:
         NS_ABORT_MSG("Unknown modulation class: " << modulation);
         return MHz_u{0};
@@ -281,6 +317,8 @@
     case WifiChannelWidthType::CW_160MHZ:
     case WifiChannelWidthType::CW_80_PLUS_80MHZ:
         return MHz_u{160};
+    case WifiChannelWidthType::CW_320MHZ:
+        return MHz_u{320};
     case WifiChannelWidthType::CW_2160MHZ:
         return MHz_u{2160};
     default:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-phy-common.h ns-3.45/src/wifi/model/wifi-phy-common.h
--- ns-3.44/src/wifi/model/wifi-phy-common.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-phy-common.h	2025-06-01 20:34:45.629702300 -0700
@@ -19,6 +19,7 @@
 #include "ns3/ptr.h"
 
 #include <ostream>
+#include <set>
 #include <vector>
 
 /**
@@ -39,9 +40,6 @@
 class WifiMode;
 class Time;
 
-/// maximum propagation delay
-static constexpr uint8_t MAX_PROPAGATION_DELAY_USEC = 1;
-
 /**
  * typedef for a pair of start and stop frequencies to represent a band
  */
@@ -515,7 +513,8 @@
     WIFI_CHANLIST_PRIMARY = 0,
     WIFI_CHANLIST_SECONDARY,
     WIFI_CHANLIST_SECONDARY40,
-    WIFI_CHANLIST_SECONDARY80
+    WIFI_CHANLIST_SECONDARY80,
+    WIFI_CHANLIST_SECONDARY160
 };
 
 /**
@@ -538,8 +537,10 @@
         return (os << "SECONDARY40");
     case WIFI_CHANLIST_SECONDARY80:
         return (os << "SECONDARY80");
+    case WIFI_CHANLIST_SECONDARY160:
+        return (os << "SECONDARY160");
     default:
-        NS_FATAL_ERROR("Unknown wifi channel type");
+        NS_FATAL_ERROR("Unknown wifi channel type " << +type);
         return (os << "UNKNOWN");
     }
 }
@@ -572,6 +573,8 @@
         return (os << "160MHz");
     case WifiChannelWidthType::CW_80_PLUS_80MHZ:
         return (os << "80+80MHz");
+    case WifiChannelWidthType::CW_320MHZ:
+        return (os << "320MHz");
     case WifiChannelWidthType::CW_2160MHZ:
         return (os << "2160MHz");
     default:
@@ -682,6 +685,15 @@
 WifiModulationClass GetModulationClassForStandard(WifiStandard standard);
 
 /**
+ * Get the supported channel width set that can be advertised in PHY capabilities.
+ *
+ * @param standard the standard
+ * @param band the PHY band
+ * @return the supported channel width set that can be advertised for the given standard and band
+ */
+std::set<MHz_u> GetSupportedChannelWidthSet(WifiStandard standard, WifiPhyBand band);
+
+/**
  * Get the maximum channel width allowed for the given modulation class.
  *
  * @param modulation the modulation class
@@ -705,6 +717,17 @@
  */
 bool IsEht(WifiPreamble preamble);
 
+/**
+ * @brief map a given channel list type to the corresponding scaling factor
+ */
+const std::map<WifiChannelListType, dBm_u> channelTypeToScalingFactor{
+    {WIFI_CHANLIST_PRIMARY, 0.0},
+    {WIFI_CHANLIST_SECONDARY, 0.0},
+    {WIFI_CHANLIST_SECONDARY40, 3.0},
+    {WIFI_CHANLIST_SECONDARY80, 6.0},
+    {WIFI_CHANLIST_SECONDARY160, 12.0},
+};
+
 } // namespace ns3
 
 #endif /* WIFI_PHY_COMMON_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-phy.h ns-3.45/src/wifi/model/wifi-phy.h
--- ns-3.44/src/wifi/model/wifi-phy.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-phy.h	2025-06-01 20:34:45.630702300 -0700
@@ -117,7 +117,8 @@
      * @return if the PHY is busy decoding the PHY header fields of a PPDU, return the TXVECTOR
      *         used to transmit the PPDU; otherwise, return a null optional value
      */
-    std::optional<std::reference_wrapper<const WifiTxVector>> GetInfoIfRxingPhyHeader() const;
+    virtual std::optional<std::reference_wrapper<const WifiTxVector>> GetInfoIfRxingPhyHeader()
+        const;
 
     /**
      * For HE receptions only, check and possibly modify the transmit power restriction state at
@@ -429,18 +430,6 @@
      * @return the PIFS duration
      */
     Time GetPifs() const;
-    /**
-     * Return the estimated Ack TX time for this PHY.
-     *
-     * @return the estimated Ack TX time
-     */
-    Time GetAckTxTime() const;
-    /**
-     * Return the estimated BlockAck TX time for this PHY.
-     *
-     * @return the estimated BlockAck TX time
-     */
-    Time GetBlockAckTxTime() const;
 
     /**
      * Get the maximum PSDU size in bytes for the given modulation class.
@@ -895,13 +884,21 @@
     dB_u GetRxGain() const;
 
     /**
+     * Get the remaining time to preamble detection period to elapse, if preamble detection is
+     * ongoing.
+     *
+     * @return the remaining time to the end of the preamble detection detection period, if ongoing
+     */
+    virtual std::optional<Time> GetTimeToPreambleDetectionEnd() const;
+
+    /**
      * Get the remaining time to the end of the MAC header reception of the next MPDU being
      * received from the given STA, if any.
      *
      * @param staId the STA-ID of the transmitter; equals SU_STA_ID for SU PPDUs
      * @return the remaining time to the end of the MAC header reception of the next MPDU, if any
      */
-    std::optional<Time> GetTimeToMacHdrEnd(uint16_t staId) const;
+    virtual std::optional<Time> GetTimeToMacHdrEnd(uint16_t staId) const;
 
     /**
      * Sets the device this PHY is associated with.
@@ -1611,11 +1608,9 @@
     WifiPhyOperatingChannel m_operatingChannel; //!< Operating channel
     bool m_fixedPhyBand; //!< True to prohibit changing PHY band after initialization
 
-    Time m_sifs;           //!< Short Interframe Space (SIFS) duration
-    Time m_slot;           //!< Slot duration
-    Time m_pifs;           //!< PCF Interframe Space (PIFS) duration
-    Time m_ackTxTime;      //!< estimated Ack TX time
-    Time m_blockAckTxTime; //!< estimated BlockAck TX time
+    Time m_sifs; //!< Short Interframe Space (SIFS) duration
+    Time m_slot; //!< Slot duration
+    Time m_pifs; //!< PCF Interframe Space (PIFS) duration
 
     dBm_u m_rxSensitivity;  //!< Receive sensitivity threshold
     dBm_u m_ccaEdThreshold; //!< Clear channel assessment (CCA) energy detection (ED) threshold
@@ -1644,6 +1639,8 @@
 
     Time m_channelSwitchDelay; //!< Time required to switch between channel
 
+    MHz_u m_maxRadioBw; //!< Maximum radio bandwidth
+
     Ptr<WifiNetDevice> m_device;   //!< Pointer to the device
     Ptr<MobilityModel> m_mobility; //!< Pointer to the mobility model
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-phy-listener.h ns-3.45/src/wifi/model/wifi-phy-listener.h
--- ns-3.44/src/wifi/model/wifi-phy-listener.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-phy-listener.h	2025-06-01 20:34:45.629702300 -0700
@@ -17,6 +17,8 @@
 namespace ns3
 {
 
+class WifiTxVector;
+
 /**
  * @brief receive notifications about PHY events.
  */
@@ -51,11 +53,13 @@
      */
     virtual void NotifyRxEndOk() = 0;
     /**
+     * @param txVector the TXVECTOR used for transmission
+     *
      * We have received the last bit of a packet for which
      * NotifyRxStart was invoked first and, the packet has
      * _not_ been successfully received.
      */
-    virtual void NotifyRxEndError() = 0;
+    virtual void NotifyRxEndError(const WifiTxVector& txVector) = 0;
     /**
      * @param duration the expected transmission duration.
      * @param txPower the nominal TX power
